// Socket emisor

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <winsock2.h>

main()
{
	SOCKET sock;
	WSADATA wsaData;
	struct sockaddr_in addr_local,addr_remoto;
	int err;
	char texto_enviado[100];
 
	err = WSAStartup( 0x0202, &wsaData );
	if ( err != 0 ) {
		printf("Versin Windows Sockets no vlida\n");
	    return 0 ;
	}

	sock=socket(AF_INET,SOCK_STREAM,0);
	if (sock==INVALID_SOCKET)
	{
		printf("Error creando socket\n");
		return 0;
	}

	addr_local.sin_family=AF_INET;
	addr_local.sin_port=htons(5000);
	addr_local.sin_addr.S_un.S_addr=inet_addr("127.0.0.1"); /* localhost = 127.0.0.1 */
	memset(addr_local.sin_zero,0,8*sizeof(char));
	err= bind(sock,(struct sockaddr*) &addr_local,sizeof(struct sockaddr_in));

	if (err==SOCKET_ERROR)
	{
		printf("Error bind socket\n");
		return 0;
	}


	addr_remoto.sin_family=AF_INET;
	addr_remoto.sin_port=htons(6000);
	addr_remoto.sin_addr.S_un.S_addr=inet_addr("127.0.0.1");
	memset(addr_remoto.sin_zero,0,8*sizeof(char));

	printf("Pulsa RETURN para conectar");
	getchar();
	err=connect(sock,(struct sockaddr*) &addr_remoto,sizeof(struct sockaddr_in));
	if (err==SOCKET_ERROR)
	{
		printf("No he podido conectar. No envo. Error %d\n",WSAGetLastError());
		fflush(stdin);
		getchar();

		return 0;
	}
	
	printf("Conectado\n");

	while (1)
	{
		printf("Dame cadena a enviar: ");
		gets(texto_enviado);

		send(sock,texto_enviado,strlen(texto_enviado)+1,0);

		if (strcmp(texto_enviado,"EXIT")==0)
			break;
	}

	closesocket(sock);

	printf("Conexin terminada. Pulse RETURN para acabar");
	fflush(stdin);
	getchar();

	return 0;

}
