// Socket receptor

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <winsock2.h>

main()
{
	SOCKET sock,connected;
	WSADATA wsaData;
	struct sockaddr_in addr_local,addr_remoto;
	int addr_len;
	int err;
	char textorecibido[100];

	err = WSAStartup( 0x0202, &wsaData );
	if ( err != 0 ) {
		printf("Versin Windows Sockets no vlida\n");
	    return 0 ;
	}

	sock=socket(AF_INET,SOCK_STREAM,0);
	if (sock==INVALID_SOCKET)
	{
		printf("Error creando socket\n");
		return 0;
	}
	
	addr_local.sin_family=AF_INET;
	addr_local.sin_port=htons(6000);
	addr_local.sin_addr.S_un.S_un_b.s_b1=127;
	addr_local.sin_addr.S_un.S_un_b.s_b2=0;
	addr_local.sin_addr.S_un.S_un_b.s_b3=0;
	addr_local.sin_addr.S_un.S_un_b.s_b4=1;
	memset(addr_local.sin_zero,0,8*sizeof(char));
	err= bind(sock,(struct sockaddr*) &addr_local,sizeof(struct sockaddr_in));

	if (err==SOCKET_ERROR)
	{
		printf("Error bind socket\n");
		return 0;
	}

	err=listen(sock,1);
	if (err==SOCKET_ERROR)
	{
		printf("Escucha no vlida: %d\n",WSAGetLastError());
	}

	printf("Esperando conexin...");

	addr_len=sizeof(struct sockaddr_in);
	connected=accept(sock,(struct sockaddr*) &addr_remoto,&addr_len);
	if (connected==INVALID_SOCKET)
		printf("No se puede aceptar la conexin\n");
	else
		printf("Conectado\nEsperando datos...");

	while (1)
	{
		err=recv(connected,textorecibido,100,0);
		printf("Recibido: %s\n",textorecibido);
		if (strcmp(textorecibido,"EXIT")==0)
			break;
	}

	closesocket(connected);
	closesocket(sock);

	printf("Conexin terminada. Pulse RETURN para acabar");
	fflush(stdin);
	getchar();

	return 0;

}
